var CC=Components.classes;
var CI=Components.interfaces;

// get hexadecimal value from character
function tohex(ch)
{
  if (ch >= '0' && ch <= '9')
    return (ch - '0');
  if (ch >= 'A' && ch <= 'F')
    return (ch - 'A' + 10);
  return -1;
}

// Decode Quoted-printable line and append result to array
function DecodeQPLine(line, data)
{
  var len = line.length;
  var addnl = true;
  var out = data.length;
  if (line.charAt(len - 1) == '\r')
    len--;
  for (var i = 0; i < len; i++) {
    if (line[i] == '=') {
      if (i < len - 2 && tohex(line[i + 1]) >= 0
	  && tohex(line[i + 2]) >= 0) {
	data[out++] = tohex(line[i + 1]) * 16 + tohex(line[i + 2]);
	i += 2;
      }
      //just in case of multilines
      else if (i < len - 1 && line[i + 1] == '\n')
	i++;
      else if (i < len - 1 && line[i + 1] == '\r')
	i += 2;
      //multiline case ends
      else if (i == len - 1)
	addnl = false;
      else
	data[out++] = line.charCodeAt(i);
    } else {
      data[out++] = line.charCodeAt(i);
    }
  }
  if (addnl)
    data[out++] = 10;		//'\n';
  return out;
}

//Decode Quoted-printable line to string and return it
function DecodeQPLineToString(line)
{
  var len = line.length;
  var addnl = true;
  var out = '';
  if (line.charAt(len - 1) == '\r')
    len--;
  for (var i = 0; i < len; i++) {
    if (line[i] == '=') {
      if (i < len - 2 && tohex(line[i + 1]) >= 0
	  && tohex(line[i + 2]) >= 0) {
	out += String.fromCharCode(tohex(line[i + 1]) * 16 + tohex(line[i + 2]));
	i += 2;
      }
      //just in case of multilines
      else if (i < len - 1 && line[i + 1] == '\n')
	i++;
      else if (i < len - 1 && line[i + 1] == '\r')
	i += 2;
      //multiline case ends
      else if (i == len - 1)
	addnl = false;
      else
	out += line[i];
    } else {
      out += line[i]
    }
  }
  if (addnl)
    out+='\n';
  return out;
}

// recode from charcode to base-64 value
function tobase64(ch)
{
  if (ch >= 65 && ch <= 90)
    return (ch - 65) + 0;
  if (ch >= 97 && ch <= 122)
    return (ch - 97) + 26;
  if (ch >= 48 && ch <= 57)
    return (ch - 48) + 52;
  if (ch == 43)
    return 62;
  if (ch == 47)
    return 63;
  if (ch == 61)
    return 0;
  return -1;
}

// Decode BASE64 line and append result to array
function DecodeB64Line(line, data)
{
  var len = line.length;
  var out = data.length;
  var tdata = 0;
  var c = 0, pos = 0;
  for (var i = 0; i < line.length; i++) {
    c = tobase64(line.charCodeAt(i));
    if (c == -1) {
      continue;
    }
    tdata = (tdata << 6) | c;
    pos++;
    if (pos == 4) {
      pos = 0;
      if (c == 0) {
	if ((tdata & 0xFFF) == 0) {
	  data[out++] = (tdata >> 16) & 0xFF;
	} else {
	  data[out++] = (tdata >> 16) & 0xFF;
	  data[out++] = (tdata >> 8) & 0xFF;
	}
      } else {
	data[out++] = (tdata >> 16) & 0xFF;
	data[out++] = (tdata >> 8) & 0xFF;
	data[out++] = (tdata & 0xFF);
      }
      tdata = 0;
    }
  }
  return out;
}

// Decode BASE64 encoded line and return result as string
function DecodeB64LineToString(line)
{
  var len = line.length;
  var out = '';
  var tdata = 0;
  var c = 0, pos = 0;
  for (var i = 0; i < line.length; i++) {
    c = tobase64(line.charCodeAt(i));
    if (c == -1) {
      continue;
    }
    tdata = (tdata << 6) | c;
    pos++;
    if (pos == 4) {
      pos = 0;
      if (c == 0) {
	if ((tdata & 0xFFF) == 0) {
	  out += String.fromCharCode((tdata >> 16) & 0xFF);
	} else {
	  out += String.fromCharCode((tdata >> 16) & 0xFF);
	  out += String.fromCharCode((tdata >> 8) & 0xFF);
	}
      } else {
        out += String.fromCharCode((tdata >> 16) & 0xFF, (tdata >> 8) & 0xFF, (tdata & 0xFF));
      }
      tdata = 0;
    }
  }
  return out;
}

// Creates new base-64 encoded stream from original
var Base64Cod = new Array('A', 'B', 'C', 'D', 'E', 'F', 'G', 'H',
			  'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P',
			  'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X',
			  'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f',
			  'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n',
			  'o', 'p', 'q', 'r', 's', 't', 'u', 'v',
			  'w', 'x', 'y', 'z', '0', '1', '2', '3',
			  '4', '5', '6', '7', '8', '9', '+', '/');

// BASE64-encode from array to string and return it
function EncodeB64(idata)
{
  var b64 = "";
  var data = 0;
  var pos1 = 0, pos2 = 0;
  for (i = 0; i < idata.length; i++) {
    var t = idata[i];
    data = data * 256 + t;
    pos1++;
    if (pos1 == 3) {
      pos1 = 0;
      b64 += Base64Cod[(data >> 18) & 0x3F];
      b64 += Base64Cod[(data >> 12) & 0x3F];
      b64 += Base64Cod[(data >> 6) & 0x3F];
      b64 += Base64Cod[data & 0x3F];
      data = 0;
      pos2 += 4;
      if (pos2 == 72) {
	pos2 = 0;
	b64 += "\r\n";
      }
    }
  }
  if (pos1 == 2) {
    data <<= 2;
    pos1 = 0;
    b64 += Base64Cod[(data >> 12) & 0x3F];
    b64 += Base64Cod[(data >> 6) & 0x3F];
    b64 += Base64Cod[data & 0x3F];
    b64 += '=';
    pos2 += 4;
  } else if (pos1 == 1) {
    data <<= 4;
    pos1 = 0;
    b64 += Base64Cod[(data >> 6) & 0x3F];
    b64 += Base64Cod[data & 0x3F];
    b64 += '=';
    b64 += '=';
    pos2 += 4;
  }
  if (pos2 > 0) {
    b64 += '\r\n';
  }
  return b64;
}

// BASE64-encode from nsIInputStream to string and return it
function EncodeB64Stream(strm){
 var ss=CC['@mozilla.org/binaryinputstream;1'].createInstance(CI.nsIBinaryInputStream);
 ss.setInputStream(strm);
 var is=CC['@mozilla.org/io/string-input-stream;1'].createInstance(CI.nsIStringInputStream);
 var b64='';
 var pos1=0,pos2=0,data=0;
 while(ss.available()>0){
  var t=ss.read8();
  data=data*256+t;
  pos1++;
  if(pos1==3){
   pos1=0;
   b64+=Base64Cod[(data>>18)&0x3F];
   b64+=Base64Cod[(data>>12)&0x3F];
   b64+=Base64Cod[(data>>6)&0x3F];
   b64+=Base64Cod[data&0x3F];
   data=0;
   pos2+=4;
   if(pos2==72){
    pos2=0;
    b64+="\r\n";
   }
  }
 }
 if(pos1==2){
  data<<=2;
  pos1=0;
  b64+=Base64Cod[(data>>12)&0x3F];
  b64+=Base64Cod[(data>>6)&0x3F];
  b64+=Base64Cod[data&0x3F];
  b64+='=';
  pos2+=4;
 }else if(pos1==1){
  data<<=4;
  pos1=0;
  b64+=Base64Cod[(data>>6)&0x3F];
  b64+=Base64Cod[data&0x3F];
  b64+='=';
  b64+='=';
  pos2+=4; 
 }
 if(pos2>0){
  b64+='\r\n';
 }
 ss.close()
 is.setData(b64,-1);
 return is;
}

// conversion from character code to QP code
var QPCod =
    new Array('=00', '=01', '=02', '=03', '=04', '=05', '=06', '=07',
	      '=08', '\t', '=0A', '=0B', '=0C', '=0D', '=0E', '=0F',
	      '=10', '=11', '=12', '=13', '=14', '=15', '=16', '=17',
	      '=18', '=19', '=1A', '=1B', '=1C', '=1D', '=1E', '=1F',
	      ' ', '!', '"', '#', '$', '%', '&', "'",
	      '(', ')', '*', '+', ',', '-', '.', '/',
	      '0', '1', '2', '3', '4', '5', '6', '7',
	      '8', '9', ':', ';', '<', '=3D', '>', '?',
	      '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G',
	      'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
	      'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W',
	      'X', 'Y', 'Z', '[', '\\', ']', '^', '_',
	      '`', 'a', 'b', 'c', 'd', 'e', 'f', 'g',
	      'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o',
	      'p', 'q', 'r', 's', 't', 'u', 'v', 'w',
	      'x', 'y', 'z', '{', '|', '}', '~', '=7F',
	      '=80', '=81', '=82', '=83', '=84', '=85', '=86', '=87',
	      '=88', '=89', '=8A', '=8B', '=8C', '=8D', '=8E', '=8F',
	      '=90', '=91', '=92', '=93', '=94', '=95', '=96', '=97',
	      '=98', '=99', '=9A', '=9B', '=9C', '=9D', '=9E', '=9F',
	      '=A0', '=A1', '=A2', '=A3', '=A4', '=A5', '=A6', '=A7',
	      '=A8', '=A9', '=AA', '=AB', '=AC', '=AD', '=AE', '=AF',
	      '=B0', '=B1', '=B2', '=B3', '=B4', '=B5', '=B6', '=B7',
	      '=B8', '=B9', '=BA', '=BB', '=BC', '=BD', '=BE', '=BF',
	      '=C0', '=C1', '=C2', '=C3', '=C4', '=C5', '=C6', '=C7',
	      '=C8', '=C9', '=CA', '=CB', '=CC', '=CD', '=CE', '=CF',
	      '=D0', '=D1', '=D2', '=D3', '=D4', '=D5', '=D6', '=D7',
	      '=D8', '=D9', '=DA', '=DB', '=DC', '=DD', '=DE', '=DF',
	      '=E0', '=E1', '=E2', '=E3', '=E4', '=E5', '=E6', '=E7',
	      '=E8', '=E9', '=EA', '=EB', '=EC', '=ED', '=EE', '=EF',
	      '=F0', '=F1', '=F2', '=F3', '=F4', '=F5', '=F6', '=F7',
	      '=F8', '=F9', '=FA', '=FB', '=FC', '=FD', '=FE', '=FF');

// QP-encode from array to string and return it
function EncodeQP(idata)
{
  var qp = "";
  var pos = 0;
  for (i = 0; i < idata.length; i++) {
    qp += QPCod[idata[i]];
    pos++;
    if (pos == 75) {
      qp += '=\r\n';
      pos = 0;
    }
  }
  if (pos)
    qp += '\r\n';
  return qp;
}

// QP-encode from string to string and return it
function EncodeQPLine(idata)
{
  var qp = "";
  var pos = 0;
  for (i = 0; i < idata.length; i++) {
    qp += QPCod[idata.charCodeAt(i)];
    pos++;
    if (pos == 75) {
      qp += '=\r\n';
      pos = 0;
    }
  }
  if (pos)
    qp += '\r\n';
  return qp;
}

// QP-encode from nsIInputStream to string and return it
function EncodeQPStream(idata)
{
  var qp = "";
  var pos = 0;
  var bis=CC['@mozilla.org/binaryinputstream;1'].createInstance(CI.nsIBinaryInputStream);
  bis.setInputStream(idata);
  for (i = 0; i < bis.available; i++) {
    qp += QPCod[idata.read8()];
    pos++;
    if (pos == 75) {
      qp += '=\r\n';
      pos = 0;
    }
  }
  if (pos)
    qp += '\r\n';
  return qp;
}
