var CC=Components.classes;
var CI=Components.interfaces;

function MIMEEncoder(){
 this.boundary = null;
 this.mstream = null;
 //MIME parts boundary
 this.boundary = "--MIMEboundary"+new Date().getTime();
 //Main input stream - will contain anything else
 this.mstream = CC['@mozilla.org/io/multiplex-input-stream;1'].
   createInstance(CI.nsIMultiplexInputStream);
 //CID of first stream
 this.start = null;
 this.starttype = null;
 //CID first part
 this.CID1 = 'msg'+new Date().getTime()+'-';
 this.CID2 = '@soapcall.none';
}

// Creates new base-64 encoded stream from original
var Base64Cod=new Array(
'A','B','C','D','E','F','G','H',
'I','J','K','L','M','N','O','P',
'Q','R','S','T','U','V','W','X',
'Y','Z','a','b','c','d','e','f',
'g','h','i','j','k','l','m','n',
'o','p','q','r','s','t','u','v',
'w','x','y','z','0','1','2','3',
'4','5','6','7','8','9','+','/');

function base64Stream(strm){
 var ss=CC['@mozilla.org/binaryinputstream;1'].createInstance(CI.nsIBinaryInputStream);
 ss.setInputStream(strm);
 var is=CC['@mozilla.org/io/string-input-stream;1'].createInstance(CI.nsIStringInputStream);
 var b64='';
 var pos1=0,pos2=0,data=0;
 while(ss.available()>0){
  var t=ss.read8();
  data=data*256+t;
  pos1++;
  if(pos1==3){
   pos1=0;
   b64+=Base64Cod[(data>>18)&0x3F];
   b64+=Base64Cod[(data>>12)&0x3F];
   b64+=Base64Cod[(data>>6)&0x3F];
   b64+=Base64Cod[data&0x3F];
   data=0;
   pos2+=4;
   if(pos2==72){
    pos2=0;
    b64+="\r\n";
   }
  }
 }
 if(pos1==2){
  data<<=2;
  pos1=0;
  b64+=Base64Cod[(data>>12)&0x3F];
  b64+=Base64Cod[(data>>6)&0x3F];
  b64+=Base64Cod[data&0x3F];
  b64+='=';
  pos2+=4;
 }else if(pos1==1){
  data<<=4;
  pos1=0;
  b64+=Base64Cod[(data>>6)&0x3F];
  b64+=Base64Cod[data&0x3F];
  b64+='=';
  b64+='=';
  pos2+=4; 
 }
 if(pos2>0){
  b64+='\r\n';
 }
 ss.close()
 is.setData(b64,-1);
 return is;
}

// creates new stream for MIME boundary
function mimeSeparator(boundary){
 var is=CC['@mozilla.org/io/string-input-stream;1'].createInstance(CI.nsIStringInputStream);
 is.setData("\r\n"+boundary+"\r\n",-1);
 return is;
}

// Return CID from name
MIMEEncoder.prototype.getCID = function(name) {
 return this.CID1+name+this.CID2;
}


// Add new stream 'stream' with id 'id' and type 'type' to MIME message
// 'encode' tells if stream should be encoded with base-64
MIMEEncoder.prototype.addStream = function(id,type,stream,encode) {
 var ms = CC['@mozilla.org/network/mime-input-stream;1'].
           createInstance(CI.nsIMIMEInputStream);
 ms.addHeader('Content-Type',type);
 ms.addHeader('Content-ID','<'+id+'>');
 if(encode == true){
  ms.addHeader('Content-Transfer-Encoding','base64');
  ms.setData(base64Stream(stream));
 }else{
  ms.addHeader('Content-Transfer-Encoding','8bit');
  ms.setData(stream);
 }
 this.mstream.appendStream(mimeSeparator(this.boundary));
 this.mstream.appendStream(ms);
 if(this.start==null){
  this.start = id;
  this.starttype = type;
 }
}

// Add new stream
MIMEEncoder.prototype.addStream = function(id,stream,encode) {
 var ms = CC['@mozilla.org/network/mime-input-stream;1'].
           createInstance(CI.nsIMIMEInputStream);
 
 var type=null;
 try{
  var idx = id.indexOf('@');
  var idx2 = id.lastIndexOf('.',idx);
  var fn = id.substr(idx2+1,idx-idx2-1);
  var MS = CC['@mozilla.org/mime;1'].getService(CI.nsIMIMEService);
  type = MS.getTypeFromExtension(fn);
 }
 catch(e){
  type = "application/octet-stream";
 }
 ms.addHeader('Content-Type',type);
 ms.addHeader('Content-ID','<'+id+'>');
 if(encode == true){
  ms.addHeader('Content-Transfer-Encoding','base64');
  ms.setData(base64Stream(stream));
 }else{
  ms.addHeader('Content-Transfer-Encoding','8bit');
  ms.setData(stream);
 }
 this.mstream.appendStream(mimeSeparator(this.boundary));
 this.mstream.appendStream(ms);
 if(this.start==null){
  this.start = id;
  this.starttype = type;
 }
}

//Generate header content-type
function getContentType(enc) {
 return "Multipart/Related; "+"boundary=" + enc.boundary.substr(2,enc.boundary.length-2)+";"+"start=\""+enc.start+"\"; type="+enc.starttype;
}

// serialize message to string
MIMEEncoder.prototype.makeString = function(){
 var ss = CC['@mozilla.org/scriptableinputstream;1'].
              createInstance(CI.nsIScriptableInputStream);
 this.mstream.appendStream(mimeSeparator(this.boundary+"--"));
 ss.init(this.mstream);
 var data = ss.read(ss.available());
 return data;
}

// display message
MIMEEncoder.prototype.show = function(){
 var str = "MIME-Version: 1.0\r\n"+
  "Content-Type: "+getContentType(this)+"\r\n\r\n";
 alert(str+this.makeString()); 
}

// prepare message for XMLHttpRequest
// call it before open() and send() !!!
MIMEEncoder.prototype.prepare = function(request) {
 request.setRequestHeader("MIME-Version","1.0");
 request.setRequestHeader("Content-Type",getContentType(this));
}
 